/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-TEMP.aml, Wed Sep  9 18:45:15 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000248 (584)
 *     Revision         0x02
 *     Checksum         0x37
 *     OEM ID           "T450"
 *     OEM Table ID     "TEMPFANS"
 *     OEM Revision     0x00000000 (0)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20180427 (538444839)
 */
DefinitionBlock ("", "SSDT", 2, "T450", "TEMPFANS", 0x00000000)
{
    External (_SB_.PCI0.LPC_.EC__, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.LPC_.EC__.HFSP, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.LPC_.EC__.HSPD, FieldUnitObj)    // (from opcode)
    External (_SB_.PCI0.LPC_.EC__.TMP0, FieldUnitObj)    // (from opcode)

    Scope (_SB.PCI0.LPC.EC)
    {
        OperationRegion (FRAM, EmbeddedControl, Zero, 0x0100)
        Field (FRAM, ByteAcc, NoLock, Preserve)
        {
            Offset (0x84), 
            HSP0,   8, 
            HSP1,   8
        }
    }

    Device (SMCD)
    {
        Name (_HID, "FAN00000")  // _HID: Hardware ID
        Name (TACH, Package (0x02)
        {
            "System Fan", 
            "FAN0"
        })
        Method (FAN0, 0, NotSerialized)
        {
            Store (\_SB.PCI0.LPC.EC.HSPD, Local0)
            Return (Local0)
        }

        Method (TCPU, 0, NotSerialized)
        {
            Store (\_SB.PCI0.LPC.EC.TMP0, Local0)
            If (LGreaterEqual (Local0, 0x55))
            {
                Store (0x07, \_SB.PCI0.LPC.EC.HFSP)
            }
            ElseIf (LGreaterEqual (Local0, 0x50))
            {
                Store (0x06, \_SB.PCI0.LPC.EC.HFSP)
            }
            ElseIf (LGreaterEqual (Local0, 0x4B))
            {
                Store (0x05, \_SB.PCI0.LPC.EC.HFSP)
            }
            ElseIf (LGreaterEqual (Local0, 0x46))
            {
                Store (0x04, \_SB.PCI0.LPC.EC.HFSP)
            }
            ElseIf (LGreaterEqual (Local0, 0x41))
            {
                Store (0x03, \_SB.PCI0.LPC.EC.HFSP)
            }
            ElseIf (LGreaterEqual (Local0, 0x3C))
            {
                Store (0x02, \_SB.PCI0.LPC.EC.HFSP)
            }
            ElseIf (LGreaterEqual (Local0, One))
            {
                Store (One, \_SB.PCI0.LPC.EC.HFSP)
            }

            Return (Local0)
        }

        Method (_STA, 0, NotSerialized)  // _STA: Status
        {
            If (_OSI ("Darwin"))
            {
                Return (0x0F)
            }
            Else
            {
                Return (Zero)
            }
        }
    }
}

